if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

--this module
lib.garrison = {}
local this = lib.garrison

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
	this.private.BFAMissions = nil
	
	this.private.set = true
end

this.BFA = {}

function this.BFA.Update()
	this.private.Validate()
	
	this.private.BFAMissions = nil
	local missions = C_Garrison.GetAvailableMissions(LE_FOLLOWER_TYPE_GARRISON_8_0)

	--this character does not hace access to BFA missions
	if(missions == nil) then
		return
	end
	
	this.private.BFAMissions = {}	
	for i, mission in pairs(missions) do
		this.private.BFAMissions[i] = {}
		local MyMission = this.private.BFAMissions[i]
		MyMission.Name = mission.name
		MyMission.ID = mission.missionID
		MyMission.TimeToExpire = mission.offerTimeRemaining
	end

	return
end

function this.BFA.GetMissions()
	this.private.Validate()
	
	return this.private.BFAMissions
end

