if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

--this module
lib.transmog = {}
local this = lib.transmog

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
	end
	return
end

function this.private.Init()
	if(this.private.set) then
		return
	end
	
end

function this.GetSourceFromItemString(ItemString)
	return (select(2, C_TransmogCollection.GetItemInfo(ItemString)))
end

function this.IsAppearanceCollectedBySource(SourceID)
	this.private.Validate()
	
	--debug test
	local SourceInfo = C_TransmogCollection.GetAppearanceInfoBySource(SourceID)
	if(SourceInfo == nil) then
		lib.chat.error("character unable to use appearance of source: "..SourceID.." - "..(select(6, C_TransmogCollection.GetAppearanceSourceInfo(SourceID))))
	end
	
	--we need to consider the TransmogCompletionist option here
	if(C_TransmogCollection.GetAppearanceInfoBySource(SourceID).sourceIsCollected == true) then
		--if we have this specific source, it's always true
		return true
	else
		if(C_TransmogCollection.GetAppearanceInfoBySource(SourceID).appearanceIsCollected == true) then
			--check the option
			if(option.TransmogCompletionist == true) then
				return false
			else
				return true
			end
		else
			return false
		end
	end
end

function this.IsSpecificSourceCollected(SourceID)
	this.private.Validate()
	
	return C_TransmogCollection.GetAppearanceInfoBySource(SourceID).sourceIsCollected
end

function this.GetItemLinkFromSource(SourceID)
	this.private.Validate()
	
	return (select(6, C_TransmogCollection.GetAppearanceSourceInfo(SourceID)))
end
