if(ThingsToDo2 == nil) then
	ThingsToDo2 = {}
end
local ttd2 = ThingsToDo2

if(ttd2.lib == nil) then
	ttd2.lib = {}
end
local lib = ttd2.lib

if(ttd2.option == nil) then
	ttd2.option = {}
end
local option = ttd2.option

if(ttd2.mod == nil) then
	ttd2.mod = {}
end
local mod = ttd2.mod

--this module
ttd2.LegionFishing = {}
local this = ttd2.LegionFishing
this.Name = "[Legion] Fishing"

this.private = { set = false }
function this.private.Validate()
	if(this.private.set == false) then
		this.private.Init()
		this.private.set = true
	end
	return
end

function this.private.Init()
	if(this.private.set == true) then
		return
	end
	
	--for some quests, there are several possibilities that do share a name but not an ID
	--for the achievement, we only need one of them
	
	this.private.AchievementID = 10598
	
	--old
	--[[this.private.quests = 
	{
		{id=41270, name=nil, numIndex=1, should="Huge Mossgill Perch"},	--Huge Mossgill Perch
		{id=41612, name=nil, numIndex=1, should="Huge Mossgill Perch"},	--Huge Mossgill Perch
		{id=41613, name=nil, numIndex=1, should="Huge Mossgill Perch"},	--Huge Mossgill Perch
		{id=41279, name=nil, numIndex=3, should="Lively Runescale Koi"},	--Lively Runescale Koi
		{id=41604, name=nil, numIndex=3, should="Lively Runescale Koi"},	--Lively Runescale Koi
		{id=41605, name=nil, numIndex=3, should="Lively Runescale Koi"},	--Lively Runescale Koi
		{id=41268, name=nil, numIndex=5, should="Queen Queenfish"},	--Queen Queenfish
		{id=41265, name=nil, numIndex=7, should="Huge Cursed Queenfish"},	--Huge Cursed Queenfish
		{id=41610, name=nil, numIndex=7, should="Huge Cursed Queenfish"},	--Huge Cursed Queenfish
		{id=41611, name=nil, numIndex=7, should="Huge Cursed Queenfish"},	--Huge Cursed Queenfish
		{id=41244, name=nil, numIndex=9, should="Lively Highmountain Salmon"},	--Lively Highmountain Salmon
		{id=41596, name=nil, numIndex=9, should="Lively Highmountain Salmon"},	--Lively Highmountain Salmon
		{id=41597, name=nil, numIndex=9, should="Lively Highmountain Salmon"},	--Lively Highmountain Salmon
		{id=41243, name=nil, numIndex=11, should="Huge Highmountain Salmon"},	--Huge Highmountain Salmon
		{id=41609, name=nil, numIndex=11, should="Huge Highmountain Salmon"},	--Huge Highmountain Salmon
		{id=41266, name=nil, numIndex=13, should="Raft Fishing"},	--Raft Fishing
		{id=41278, name=nil, numIndex=15, should="Slippery Stormrays"},	--Slippery Stormrays
		{id=41277, name=nil, numIndex=17, should="Work Order: Stormrays"},	--Work Order: Stormrays
		{id=41269, name=nil, numIndex=19, should="Lively Mossgill Perch"},	--Lively Mossgill Perch
		{id=41600, name=nil, numIndex=19, should="Lively Mossgill Perch"},	--Lively Mossgill Perch
		{id=41601, name=nil, numIndex=19, should="Lively Mossgill Perch"},	--Lively Mossgill Perch
		{id=41276, name=nil, numIndex=21, should="Rocket Boot Fishing"},	--Rocket Boot Fishing
		{id=41282, name=nil, numIndex=23, should="Work Order: Runescale Koi"},	--Work Order: Runescale Koi
		{id=41267, name=nil, numIndex=2, should="Work Order: Cursed Queenfish"},	--Work Order: Cursed Queenfish
		{id=41264, name=nil, numIndex=4, should="Lively Cursed Queenfish"},	--Lively Cursed Queenfish
		{id=41598, name=nil, numIndex=4, should="Lively Cursed Queenfish"},	--Lively Cursed Queenfish
		{id=41599, name=nil, numIndex=4, should="Lively Cursed Queenfish"},	--Lively Cursed Queenfish
		{id=41252, name=nil, numIndex=6, should="Wild Northern Barracuda"},	--Wild Northern Barracuda
		{id=41280, name=nil, numIndex=8, should="Huge Runescale Koi"},	--Huge Runescale Koi
		{id=41616, name=nil, numIndex=8, should="Huge Runescale Koi"},	--Huge Runescale Koi
		{id=41617, name=nil, numIndex=8, should="Huge Runescale Koi"},	--Huge Runescale Koi
		{id=41274, name=nil, numIndex=10, should="Lively Stormrays"},	--Lively Stormrays
		{id=41602, name=nil, numIndex=10, should="Lively Stormrays"},	--Lively Stormrays
		{id=41603, name=nil, numIndex=10, should="Lively Stormrays"},	--Lively Stormrays
		{id=41273, name=nil, numIndex=12, should="Buoy Fishing"},	--Buoy Fishing
		{id=41275, name=nil, numIndex=14, should="Huge Stormrays"},	--Huge Stormrays
		{id=41614, name=nil, numIndex=14, should="Huge Stormrays"},	--Huge Stormrays
		{id=41615, name=nil, numIndex=14, should="Huge Stormrays"},	--Huge Stormrays
		{id=41271, name=nil, numIndex=16, should="Cave Fishing"},	--Cave Fishing
		{id=41240, name=nil, numIndex=18, should="Work Order: Highmountain Salmon"},	--Work Order: Highmountain Salmon
		{id=41253, name=nil, numIndex=20, should="Migrating Highmountain Salmon"},	--Migrating Highmountain Salmon
		{id=41272, name=nil, numIndex=22, should="Work Order Mossgill Perch"}, 	--Work Order Mossgill Perch
		{id=41283, name=nil, numIndex=24, should="The Angler Mangler"} 	--The Angler Mangler
	}--]]
	
	--new!
	this.private.WQuestsByCriteriaIndex =
	{ 
		{ 41270, 41612, 41613 },
		{ 41267 },
		{ 41279, 41604, 41605 },
		{ 41264, 41598, 41599 },
		{ 41268 },
		{ 41252 },
		{ 41265, 41610, 41611 },
		{ 41280, 41616, 41617 },
		{ 41244, 41596, 41597 },
		{ 41274, 41602, 41603 },
		{ 41243, 41609 },
		{ 41273 },
		{ 41266 },
		{ 41275, 41614, 41615 },
		{ 41278 },
		{ 41271 },
		{ 41277 },
		{ 41240 },
		{ 41269, 41600, 41601 },
		{ 41253 },
		{ 41276 },
		{ 41272 },
		{ 41282 },
		{ 41283 }
	}
	
	lib.achievement.AddByID(this.private.AchievementID)
	
	return
end

function this.private.CheckWorldquests(WQIDs)
	this.private.Validate()
	
	for _,WQID in ipairs(WQIDs) do
		if(lib.worldquest.IsActive(WQID) == true) then
			return WQID
		end
	end
	
	return nil
end

function this.private.Update()
	this.private.Validate()
	
	local out = lib.chat.output
	out.ClearBuffer()
	
	lib.achievement.UpdateByID(this.private.AchievementID)
	
	local Ach = lib.achievement.GetByID(this.private.AchievementID)

	--the achievemt does not require all of the criteria to be completed; for completionist purposes
	--we will still list available WQs for missing criteria even after the achievement is completed
	--UPDATE: We will use the completed2 mark if criteria are missing but the ach is completed.
	
	--to determine the status of the achievemt we need to evalutae the individual criteria first, e.g.
	--if 4 are missing but none of the WQs for those are up the total status of the aschievement is "done"
	--not "todo".
	
	local WQsUp = 0
	local CriteriaMissing = 0
	for i,crit in ipairs(Ach.CriteriaByIndex) do
		if(crit.IsCompleted == false) then
			CriteriaMissing = CriteriaMissing+1
			--look for available WQs!
			local WQ = this.private.CheckWorldquests(this.private.WQuestsByCriteriaIndex[i])
			if(WQ ~= nil) then
				WQsUp = WQsUp+1
			end
		end
	end
	
	if(	((Ach.IsCompleted == true) and (CriteriaMissing == 0)) or
		((Ach.IsCompleted == true) and (option.AchCompletionist == false)) ) then
		out.StoreCompleted(Ach.Link)
		return
	else
		--the ach is either done or todo, check WQs
		if(WQsUp == 0) then
			out.StoreDone(Ach.Link)
		else
			out.StoreTodo(Ach.Link)
		end
		
		--now loop the criteria
		for i,crit in ipairs(Ach.CriteriaByIndex) do
			if(crit.IsCompleted == true) then
				out.StoreCompleted(crit.Name)
			else
				--look for available WQs!
				local WQ = this.private.CheckWorldquests(this.private.WQuestsByCriteriaIndex[i])
				if(WQ == nil) then
					out.StoreDone(lib.chat.complex.GetWQStatusString(nil, crit.Name))
				else
					out.StoreTodo(lib.chat.complex.GetWQStatusString(WQ))
				end
			end
		end
	end
	
	return
end	

function this.CheckStatus()
	this.private.Validate()
	
	this.private.Update()
	if(lib.chat.output.GetNumLines() == 0) then
		return false
	end
	
	return true
end

function this.Script()
	this.private.Validate()
	
	this.private.Update()
	lib.chat.output.PrintModule(this.Name)
	
	return
end

mod[#mod+1] =
{
	CheckStatus	= this.CheckStatus,
	Text		= this.Name,
	Script		= this.Script
}
